import { Component, Input, ChangeDetectionStrategy } from '@angular/core';
import { DashboardTileCustomization } from "./DashboardTileCustomization";
import { TypeRegistrar } from "igniteui-angular-core";
import { NamePatcher, ensureBool, toSpinal, initializePropertiesFromCss } from "igniteui-angular-core";
import * as i0 from "@angular/core";
export let IgxDashboardTileCustomizationComponent = /*@__PURE__*/ (() => {
    class IgxDashboardTileCustomizationComponent {
        constructor() {
            this.__p = null;
            this._hasUserValues = new Set();
            this._stylingContainer = null;
            this._stylingParent = null;
            this._inStyling = false;
            if (this._styling) {
                NamePatcher.ensureStylablePatched(Object.getPrototypeOf(this));
            }
            this._implementation = this.createImplementation();
            this._implementation.externalObject = this;
            this.onImplementationCreated();
            if (this._initializeAdapters) {
                this._initializeAdapters();
            }
        }
        createImplementation() {
            return new DashboardTileCustomization();
        }
        ngOnInit() {
        }
        /**
         * @hidden
         */
        get i() {
            return this._implementation;
        } /**
                                     * @hidden
                                     */
        static _createFromInternal(internal) {
            if (!internal) {
                return null;
            }
            if (!internal.$type) {
                return null;
            }
            let name = internal.$type.name;
            let externalName = "Igx" + name + "Component";
            if (!TypeRegistrar.isRegistered(externalName)) {
                return null;
            }
            return TypeRegistrar.create(externalName);
        }
        onImplementationCreated() {
        }
        get matchType() {
            return this.i.m;
        }
        set matchType(v) {
            this.i.m = v;
        }
        get propertyName() {
            return this.i.n;
        }
        set propertyName(v) {
            this.i.n = v;
        }
        get propertyValue() {
            return this.i.l;
        }
        set propertyValue(v) {
            this.i.l = v;
        }
        get isCollectionInsertionAtEnd() {
            return this.i.c;
        }
        set isCollectionInsertionAtEnd(v) {
            this.i.c = ensureBool(v);
        }
        get isCollectionInsertionAtStart() {
            return this.i.e;
        }
        set isCollectionInsertionAtStart(v) {
            this.i.e = ensureBool(v);
        }
        get isCollectionInsertionAtIndex() {
            return this.i.d;
        }
        set isCollectionInsertionAtIndex(v) {
            this.i.d = ensureBool(v);
        }
        get isCollectionRemovaltIndex() {
            return this.i.f;
        }
        set isCollectionRemovaltIndex(v) {
            this.i.f = ensureBool(v);
        }
        get collectionIndex() {
            return this.i.i;
        }
        set collectionIndex(v) {
            this.i.i = +v;
        }
        get order() {
            return this.i.k;
        }
        set order(v) {
            this.i.k = +v;
        }
        get matchParentIndex() {
            return this.i.j;
        }
        set matchParentIndex(v) {
            this.i.j = +v;
        }
        findByName(name) {
            if (this.findEphemera) {
                if (name && name.indexOf("@@e:") == 0) {
                    return this.findEphemera(name);
                }
            }
            return null;
        }
        get hasUserValues() {
            return this._hasUserValues;
        }
        __m(propertyName) {
            if (!this._inStyling) {
                this._hasUserValues.add(propertyName);
            }
        }
        _styling(container, component, parent) {
            if (this._inStyling) {
                return;
            }
            this._inStyling = true;
            this._stylingContainer = container;
            this._stylingParent = component;
            let genericPrefix = "";
            let typeName = this.i.$type.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            genericPrefix = toSpinal("DashboardTileCustomizationComponent");
            let additionalPrefixes = [];
            let prefix = toSpinal(typeName);
            additionalPrefixes.push(prefix + "-");
            let b = this.i.$type.baseType;
            while (b && b.name != "Object" &&
                b.name != "Base" &&
                b.name != "Control" &&
                b.Name != "DependencyObject" &&
                b.Name != "FrameworkElement") {
                typeName = b.name;
                if (typeName.indexOf("Xam") === 0) {
                    typeName = typeName.substring(3);
                }
                let basePrefix = toSpinal(typeName);
                additionalPrefixes.push(basePrefix + "-");
                b = b.baseType;
            }
            if (parent) {
                let parentTypeName = parent.i.$type.name;
                if (parentTypeName.indexOf("Xam") === 0) {
                    parentTypeName = parentTypeName.substring(3);
                }
                let parentPrefix = toSpinal(parentTypeName);
                additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
                additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
            }
            initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
            if (this._otherStyling) {
                this._otherStyling(container, component, parent);
            }
            this._inStyling = false;
        }
    }
    IgxDashboardTileCustomizationComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0, type: IgxDashboardTileCustomizationComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
    IgxDashboardTileCustomizationComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.17", type: IgxDashboardTileCustomizationComponent, selector: "igx-dashboard-tile-customization", inputs: { matchType: "matchType", propertyName: "propertyName", propertyValue: "propertyValue", isCollectionInsertionAtEnd: "isCollectionInsertionAtEnd", isCollectionInsertionAtStart: "isCollectionInsertionAtStart", isCollectionInsertionAtIndex: "isCollectionInsertionAtIndex", isCollectionRemovaltIndex: "isCollectionRemovaltIndex", collectionIndex: "collectionIndex", order: "order", matchParentIndex: "matchParentIndex" }, providers: [], ngImport: i0, template: ``, isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
    return IgxDashboardTileCustomizationComponent;
})();
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0, type: IgxDashboardTileCustomizationComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'igx-dashboard-tile-customization',
                    template: ``,
                    providers: [],
                    changeDetection: ChangeDetectionStrategy.OnPush
                }]
        }], ctorParameters: function () { return []; }, propDecorators: { matchType: [{
                type: Input
            }], propertyName: [{
                type: Input
            }], propertyValue: [{
                type: Input
            }], isCollectionInsertionAtEnd: [{
                type: Input
            }], isCollectionInsertionAtStart: [{
                type: Input
            }], isCollectionInsertionAtIndex: [{
                type: Input
            }], isCollectionRemovaltIndex: [{
                type: Input
            }], collectionIndex: [{
                type: Input
            }], order: [{
                type: Input
            }], matchParentIndex: [{
                type: Input
            }] } });
