import { Component, Input, ChangeDetectionStrategy } from '@angular/core';
import { DashboardTileCustomization } from "./DashboardTileCustomization";
import { TypeRegistrar } from "igniteui-angular-core";
import { NamePatcher, ensureBool, toSpinal, initializePropertiesFromCss } from "igniteui-angular-core";
import * as i0 from "@angular/core";
var IgxDashboardTileCustomizationComponent = /** @class */ /*@__PURE__*/ (function () {
    function IgxDashboardTileCustomizationComponent() {
        this.__p = null;
        this._hasUserValues = new Set();
        this._stylingContainer = null;
        this._stylingParent = null;
        this._inStyling = false;
        if (this._styling) {
            NamePatcher.ensureStylablePatched(Object.getPrototypeOf(this));
        }
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgxDashboardTileCustomizationComponent.prototype.createImplementation = function () {
        return new DashboardTileCustomization();
    };
    IgxDashboardTileCustomizationComponent.prototype.ngOnInit = function () {
    };
    Object.defineProperty(IgxDashboardTileCustomizationComponent.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        } /**
                                     * @hidden
                                     */,
        enumerable: false,
        configurable: true
    });
    IgxDashboardTileCustomizationComponent._createFromInternal = function (internal) {
        if (!internal) {
            return null;
        }
        if (!internal.$type) {
            return null;
        }
        var name = internal.$type.name;
        var externalName = "Igx" + name + "Component";
        if (!TypeRegistrar.isRegistered(externalName)) {
            return null;
        }
        return TypeRegistrar.create(externalName);
    };
    IgxDashboardTileCustomizationComponent.prototype.onImplementationCreated = function () {
    };
    Object.defineProperty(IgxDashboardTileCustomizationComponent.prototype, "matchType", {
        get: function () {
            return this.i.m;
        },
        set: function (v) {
            this.i.m = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxDashboardTileCustomizationComponent.prototype, "propertyName", {
        get: function () {
            return this.i.n;
        },
        set: function (v) {
            this.i.n = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxDashboardTileCustomizationComponent.prototype, "propertyValue", {
        get: function () {
            return this.i.l;
        },
        set: function (v) {
            this.i.l = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxDashboardTileCustomizationComponent.prototype, "isCollectionInsertionAtEnd", {
        get: function () {
            return this.i.c;
        },
        set: function (v) {
            this.i.c = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxDashboardTileCustomizationComponent.prototype, "isCollectionInsertionAtStart", {
        get: function () {
            return this.i.e;
        },
        set: function (v) {
            this.i.e = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxDashboardTileCustomizationComponent.prototype, "isCollectionInsertionAtIndex", {
        get: function () {
            return this.i.d;
        },
        set: function (v) {
            this.i.d = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxDashboardTileCustomizationComponent.prototype, "isCollectionRemovaltIndex", {
        get: function () {
            return this.i.f;
        },
        set: function (v) {
            this.i.f = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxDashboardTileCustomizationComponent.prototype, "collectionIndex", {
        get: function () {
            return this.i.i;
        },
        set: function (v) {
            this.i.i = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxDashboardTileCustomizationComponent.prototype, "order", {
        get: function () {
            return this.i.k;
        },
        set: function (v) {
            this.i.k = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxDashboardTileCustomizationComponent.prototype, "matchParentIndex", {
        get: function () {
            return this.i.j;
        },
        set: function (v) {
            this.i.j = +v;
        },
        enumerable: false,
        configurable: true
    });
    IgxDashboardTileCustomizationComponent.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    };
    Object.defineProperty(IgxDashboardTileCustomizationComponent.prototype, "hasUserValues", {
        get: function () {
            return this._hasUserValues;
        },
        enumerable: false,
        configurable: true
    });
    IgxDashboardTileCustomizationComponent.prototype.__m = function (propertyName) {
        if (!this._inStyling) {
            this._hasUserValues.add(propertyName);
        }
    };
    IgxDashboardTileCustomizationComponent.prototype._styling = function (container, component, parent) {
        if (this._inStyling) {
            return;
        }
        this._inStyling = true;
        this._stylingContainer = container;
        this._stylingParent = component;
        var genericPrefix = "";
        var typeName = this.i.$type.name;
        if (typeName.indexOf("Xam") === 0) {
            typeName = typeName.substring(3);
        }
        genericPrefix = toSpinal("DashboardTileCustomizationComponent");
        var additionalPrefixes = [];
        var prefix = toSpinal(typeName);
        additionalPrefixes.push(prefix + "-");
        var b = this.i.$type.baseType;
        while (b && b.name != "Object" &&
            b.name != "Base" &&
            b.name != "Control" &&
            b.Name != "DependencyObject" &&
            b.Name != "FrameworkElement") {
            typeName = b.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            var basePrefix = toSpinal(typeName);
            additionalPrefixes.push(basePrefix + "-");
            b = b.baseType;
        }
        if (parent) {
            var parentTypeName = parent.i.$type.name;
            if (parentTypeName.indexOf("Xam") === 0) {
                parentTypeName = parentTypeName.substring(3);
            }
            var parentPrefix = toSpinal(parentTypeName);
            additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
            additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
        }
        initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
        if (this._otherStyling) {
            this._otherStyling(container, component, parent);
        }
        this._inStyling = false;
    };
    IgxDashboardTileCustomizationComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0, type: IgxDashboardTileCustomizationComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
    IgxDashboardTileCustomizationComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.17", type: IgxDashboardTileCustomizationComponent, selector: "igx-dashboard-tile-customization", inputs: { matchType: "matchType", propertyName: "propertyName", propertyValue: "propertyValue", isCollectionInsertionAtEnd: "isCollectionInsertionAtEnd", isCollectionInsertionAtStart: "isCollectionInsertionAtStart", isCollectionInsertionAtIndex: "isCollectionInsertionAtIndex", isCollectionRemovaltIndex: "isCollectionRemovaltIndex", collectionIndex: "collectionIndex", order: "order", matchParentIndex: "matchParentIndex" }, providers: [], ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
    return IgxDashboardTileCustomizationComponent;
}());
export { IgxDashboardTileCustomizationComponent };
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0, type: IgxDashboardTileCustomizationComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'igx-dashboard-tile-customization',
                    template: "",
                    providers: [],
                    changeDetection: ChangeDetectionStrategy.OnPush
                }]
        }], ctorParameters: function () { return []; }, propDecorators: { matchType: [{
                type: Input
            }], propertyName: [{
                type: Input
            }], propertyValue: [{
                type: Input
            }], isCollectionInsertionAtEnd: [{
                type: Input
            }], isCollectionInsertionAtStart: [{
                type: Input
            }], isCollectionInsertionAtIndex: [{
                type: Input
            }], isCollectionRemovaltIndex: [{
                type: Input
            }], collectionIndex: [{
                type: Input
            }], order: [{
                type: Input
            }], matchParentIndex: [{
                type: Input
            }] } });
