import { TemplateRef, EventEmitter, ViewContainerRef, Injector, ComponentFactoryResolver, AfterViewInit, Renderer2, QueryList, NgZone } from '@angular/core';
import { DashboardTile } from "./DashboardTile";
import { ControlDisplayDensity } from "igniteui-angular-core";
import { BaseControlTheme } from "igniteui-angular-core";
import { IgxDashboardTileFilterStringErrorsParsingEventArgs } from "./igx-dashboard-tile-filter-string-errors-parsing-event-args";
import { ICommandStateChangedListener } from "igniteui-angular-core";
import { ICommandAvailabilityListener } from "igniteui-angular-core";
import { ToolActionInfo } from "igniteui-angular-core";
import { DashboardTileVisualizationType } from "./DashboardTileVisualizationType";
import { CrosshairsDisplayMode } from "igniteui-angular-charts";
import { IgxValueModeCollection } from "igniteui-angular-charts";
import { IgxChartSelectedItemCollection } from "igniteui-angular-charts";
import { SeriesHighlightedValuesDisplayMode } from "igniteui-angular-core";
import { TrendLineType } from "igniteui-angular-core";
import { IgxDashboardTileSummaryDescriptionCollection } from "./igx-dashboard-tile-summary-description-collection";
import { IgxFilterExpressionCollection } from "igniteui-angular-core";
import { IgxDashboardTileSortDescriptionCollection } from "./igx-dashboard-tile-sort-description-collection";
import { IgxDashboardTileCustomizationComponent } from "./igx-dashboard-tile-customization-component";
import { IgxDashboardTileCustomizationCollection } from "./igx-dashboard-tile-customization-collection";
import { IgxDashboardTileChangingContentEventArgs } from "./igx-dashboard-tile-changing-content-event-args";
import * as i0 from "@angular/core";
export declare class IgxDashboardTileComponent implements AfterViewInit {
    private renderer;
    private _elRef;
    private ngZone;
    private injector;
    private componentFactoryResolver;
    container: Element;
    private _wrapper;
    private _portalManager;
    private _root;
    _dynamicContent: ViewContainerRef;
    _childTemplateRef: TemplateRef<any>;
    private _height;
    private _width;
    set height(value: string);
    get height(): string;
    set width(value: string);
    get width(): string;
    constructor(renderer: Renderer2, _elRef: ViewContainerRef, ngZone: NgZone, injector: Injector, componentFactoryResolver: ComponentFactoryResolver);
    updateStyle(): void;
    ngOnDestroy(): void;
    ngAfterViewInit(): void;
    protected createImplementation(): DashboardTile;
    protected _implementation: any;
    /**
     * @hidden
     */
    get i(): DashboardTile; /**
                                 * @hidden
                                 */
    static _createFromInternal(internal: any): IgxDashboardTileComponent;
    private _DashboardTile;
    private _customizations;
    private _actualCustomizations;
    get actualCustomizations(): IgxDashboardTileCustomizationComponent[];
    contentCustomizations: QueryList<IgxDashboardTileCustomizationComponent>;
    private _customizationsAdapter;
    /**
     * Gets a collection where you can add customization that will be applied to the generated visualizations.
    */
    get customizations(): IgxDashboardTileCustomizationCollection;
    static ngAcceptInputType_customizations: IgxDashboardTileCustomizationCollection | string;
    /**
     * Gets or sets text to display above the plot area.
    */
    get tileTitle(): string;
    set tileTitle(v: string);
    /**
     * Gets the initial sorts that are applied to the chart.
    */
    get initialSortDescriptions(): IgxDashboardTileSortDescriptionCollection;
    /**
     * Gets the initial sorts that are applied to the chart after groupings and summaries are applied.
    */
    get initialGroupSortDescriptions(): IgxDashboardTileSortDescriptionCollection;
    /**
     * Gets the initial groupings that are applied to the chart.
    */
    get initialGroupDescriptions(): IgxDashboardTileSortDescriptionCollection;
    /**
     * Gets the initial filters that are applied to the chart.
    */
    get initialFilterExpressions(): IgxFilterExpressionCollection;
    /**
     * Gets the initial highlight filters that are applied to the chart.
    */
    get initialHighlightFilterExpressions(): IgxFilterExpressionCollection;
    /**
     * Gets the initial summaries that are applied to the chart.
    */
    get initialSummaryDescriptions(): IgxDashboardTileSummaryDescriptionCollection;
    /**
     * Gets or sets the sorts to apply to the chart. This property will become ignored if sorts are changed outside of this property.
    */
    get initialSorts(): string;
    set initialSorts(v: string);
    /**
     * Gets or sets the sorts to apply after grouping has been applied.
    */
    get groupSorts(): string;
    set groupSorts(v: string);
    /**
     * Gets or sets the groupings to apply to the chart. This property will become ignored if sorts are changed outside of this property.
    */
    get initialGroups(): string;
    set initialGroups(v: string);
    /**
     * Gets or sets the filter to apply to the chart. This property will become ignored if the filter is changed outside of this property.
    */
    get initialFilter(): string;
    set initialFilter(v: string);
    /**
     * Gets or sets the filter to apply to the chart. This property will become ignored if the filter is changed outside of this property.
    */
    get initialHighlightFilter(): string;
    set initialHighlightFilter(v: string);
    /**
     * Gets or sets the summaries to apply to the chart. This property will become ignored if sorts are changed outside of this property.
    */
    get initialSummaries(): string;
    set initialSummaries(v: string);
    /**
     * Gets the current sort that is applied to the grid. Collection can be updated to modify the sort for the grid. Once sort descriptions are in this collection, the grid will no longer listen for changes on their properties.
    */
    get sortDescriptions(): IgxDashboardTileSortDescriptionCollection;
    get groupSortDescriptions(): IgxDashboardTileSortDescriptionCollection;
    /**
     * Gets the current grouping that is applied to the grid. Collection can be updated to modify the grouping for the grid. Once grouping descriptions are in this collection, the grid will no longer listen for changes on their properties.
    */
    get groupDescriptions(): IgxDashboardTileSortDescriptionCollection;
    /**
     * Gets the current filter that is applied to the chart. Collection can be updated to modify the filter for the chart. Once filter expressions are in this collection, the chart will no longer listen for changes on their properties.
    */
    get filterExpressions(): IgxFilterExpressionCollection;
    /**
     * Gets the current highlight filter that is applied to the chart. Collection can be updated to modify the highlight filter for the chart. Once filter expressions are in this collection, the chart will no longer listen for changes on their properties.
    */
    get highlightFilterExpressions(): IgxFilterExpressionCollection;
    /**
     * Gets the current summaries that are applied to the grid.
    */
    get summaryDescriptions(): IgxDashboardTileSummaryDescriptionCollection;
    /**
     * Gets or sets a collection of data items used to generate the dashboard tile.
     * The ItemsSource of this dashboard tile can be a list of objects containing one or more numeric properties.
     * Additionally, if the objects in the list implement an enumerable interface,
     * the dashboard tile will attempt to delve into the sub-collections when reading through the data source.
     * Data binding can be further configured by attributing the data item classes
     * with the data intent feature.
    */
    get dataSource(): any;
    set dataSource(v: any);
    /**
     * Gets or sets a collection of data items used to generate the dashboard tile.
     * The HighlightedItemsSource of this dashboard tile can be a list of objects containing one or more numeric properties.
     * Additionally, if the objects in the list implement an enumerable interface,
     * the dashboard tile will attempt to delve into the sub-collections when reading through the data source.
     * Data binding can be further configured by attributing the data item classes
     * with the data intent feature.
    */
    get highlightedDataSource(): any;
    set highlightedDataSource(v: any);
    /**
     * Gets or sets whether the dashboard tile should display mock data when the data source has not been provided, if supported for this type of chart.
    */
    get shouldDisplayMockData(): boolean;
    set shouldDisplayMockData(v: boolean);
    static ngAcceptInputType_shouldDisplayMockData: boolean | string;
    /**
     * Gets or sets whether annotations for the final value of each series is displayed on the axis.
    */
    get shouldAvoidAxisAnnotationCollisions(): boolean;
    set shouldAvoidAxisAnnotationCollisions(v: boolean);
    static ngAcceptInputType_shouldAvoidAxisAnnotationCollisions: boolean | string;
    /**
     * Gets or sets the formula used for calculating trend lines in this chart.
     * This property applies only to these chart types: point, line, spline, and bubble
    */
    get trendLineType(): TrendLineType;
    set trendLineType(v: TrendLineType);
    static ngAcceptInputType_trendLineType: TrendLineType | string;
    /**
     * Gets or sets whether the dashboard tile should use a faded skeleton style for mock data.
    */
    get shouldUseSkeletonStyleForMockData(): boolean;
    set shouldUseSkeletonStyleForMockData(v: boolean);
    static ngAcceptInputType_shouldUseSkeletonStyleForMockData: boolean | string;
    /**
     * Gets or sets whether and how to display highlighted values for the series. Note, this is distinct from the highlighting feature that indicates what is closest or under the mouse.
     * This property applies to Category Chart and Financial Chart controls.
    */
    get highlightedValuesDisplayMode(): SeriesHighlightedValuesDisplayMode;
    set highlightedValuesDisplayMode(v: SeriesHighlightedValuesDisplayMode);
    static ngAcceptInputType_highlightedValuesDisplayMode: SeriesHighlightedValuesDisplayMode | string;
    /**
     * Gets or sets a set of property paths that should be included for consideration by the category chart, leaving the remainder excluded. If null, all properties will be considered.
    */
    get includedProperties(): string[];
    set includedProperties(v: string[]);
    static ngAcceptInputType_includedProperties: string[] | string;
    /**
     * Gets the current set of valid visualization types for the data.
    */
    get validVisualizationTypes(): DashboardTileVisualizationType[];
    set validVisualizationTypes(v: DashboardTileVisualizationType[]);
    static ngAcceptInputType_validVisualizationTypes: DashboardTileVisualizationType[] | string;
    /**
     * Gets or sets a set of property paths that should be excluded from consideration by the category chart.
    */
    get excludedProperties(): string[];
    set excludedProperties(v: string[]);
    static ngAcceptInputType_excludedProperties: string[] | string;
    /**
     * Gets or sets the palette of brushes to use for coloring the dashboard tile.
     * The value provided should be an array of CSS color strings or JavaScript objects defining gradients. Optionally the first element can be a string reading "RGB" or "HSV" to specify the interpolation mode of the collection
    */
    get brushes(): string[];
    set brushes(v: string[]);
    static ngAcceptInputType_brushes: string[] | string;
    /**
     * Gets or sets the palette of brushes to use for outlines on the dashboard tile.
     * The value provided should be an array of CSS color strings or JavaScript objects defining gradients. Optionally the first element can be a string reading "RGB" or "HSV" to specify the interpolation mode of the collection
    */
    get outlines(): string[];
    set outlines(v: string[]);
    static ngAcceptInputType_outlines: string[] | string;
    private _selectedSeriesItems;
    /**
     * Gets the currently selected data items.  Adding or removing data items from this collection will
     * select or deselect the visuals associated with those items.
    */
    get selectedSeriesItems(): IgxChartSelectedItemCollection;
    set selectedSeriesItems(v: IgxChartSelectedItemCollection);
    static ngAcceptInputType_selectedSeriesItems: IgxChartSelectedItemCollection | string;
    /**
     * Gets the actual palette of brushes to use for coloring the chart series.
    */
    get actualBrushes(): string[];
    set actualBrushes(v: string[]);
    static ngAcceptInputType_actualBrushes: string[] | string;
    /**
     * Gets the actual palette of brushes to use for outlines on the chart series.
    */
    get actualOutlines(): string[];
    set actualOutlines(v: string[]);
    static ngAcceptInputType_actualOutlines: string[] | string;
    /**
     * Gets the brush to use for the Category axis major strokes, if applicable.
    */
    get categoryAxisMajorStroke(): string;
    set categoryAxisMajorStroke(v: string);
    private _valueLines;
    /**
     * Gets or sets what value lines to use in the chart.
    */
    get valueLines(): IgxValueModeCollection;
    set valueLines(v: IgxValueModeCollection);
    static ngAcceptInputType_valueLines: IgxValueModeCollection | string;
    /**
     * Gets or sets the palette of brushes to use for coloring the value lines present in the ValueLines property.
     * The value provided should be an array of CSS color strings or JavaScript objects defining gradients. Optionally the first element can be a string reading "RGB" or "HSV" to specify the interpolation mode of the collection
    */
    get valueLinesBrushes(): string[];
    set valueLinesBrushes(v: string[]);
    static ngAcceptInputType_valueLinesBrushes: string[] | string;
    /**
     * Gets or sets if the auto value callouts should be displayed.
    */
    get autoCalloutsVisible(): boolean;
    set autoCalloutsVisible(v: boolean);
    static ngAcceptInputType_autoCalloutsVisible: boolean | string;
    /**
     * Gets or sets whether annotations are shown along the axis for crosshair values
    */
    get crosshairsAnnotationEnabled(): boolean;
    set crosshairsAnnotationEnabled(v: boolean);
    static ngAcceptInputType_crosshairsAnnotationEnabled: boolean | string;
    /**
     * Gets or sets whether annotations for the final value of each series is displayed on the axis.
    */
    get finalValueAnnotationsVisible(): boolean;
    set finalValueAnnotationsVisible(v: boolean);
    static ngAcceptInputType_finalValueAnnotationsVisible: boolean | string;
    /**
     * Gets or sets the crosshairs to be displayed.
    */
    get crosshairsDisplayMode(): CrosshairsDisplayMode;
    set crosshairsDisplayMode(v: CrosshairsDisplayMode);
    static ngAcceptInputType_crosshairsDisplayMode: CrosshairsDisplayMode | string;
    /**
     * Gets or sets the crosshairs to be displayed.
    */
    get visualizationType(): DashboardTileVisualizationType;
    set visualizationType(v: DashboardTileVisualizationType);
    static ngAcceptInputType_visualizationType: DashboardTileVisualizationType | string;
    /**
     * Gets or sets the crosshairs to be displayed.
    */
    get validVisualizationTypePriorityThreshold(): number;
    set validVisualizationTypePriorityThreshold(v: number);
    static ngAcceptInputType_validVisualizationTypePriorityThreshold: number | string;
    /**
     * Gets or sets the base built in theme to use for the checkbox.
    */
    get baseTheme(): BaseControlTheme;
    set baseTheme(v: BaseControlTheme);
    static ngAcceptInputType_baseTheme: BaseControlTheme | string;
    /**
     * Gets or sets the display density to use for the toolbar.
    */
    get density(): ControlDisplayDensity;
    set density(v: ControlDisplayDensity);
    static ngAcceptInputType_density: ControlDisplayDensity | string;
    /**
     * Gets or sets the color to use for the background of the component.
    */
    get backgroundColor(): string;
    set backgroundColor(v: string);
    get isVisTypeStacked(): boolean;
    static ngAcceptInputType_isVisTypeStacked: boolean | string;
    get isVisTypeRadial(): boolean;
    static ngAcceptInputType_isVisTypeRadial: boolean | string;
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    updateSettingsValue(key: string, value: any): void;
    getSettingsValue(key: string): any;
    hasModifiedSettings(): boolean;
    clearSettings(): void;
    removeSettingsValue(key: string): void;
    zoomIn(percentage: number): void;
    /**
     * Performs zoom out action on the chart by specified percentage of current window rect
    
    */
    zoomOut(percentage: number): void;
    /**
     * Resets the zoom level to default.
    
    */
    resetZoom(): void;
    onUIReady(): void;
    getDesiredToolbarActions(): ToolActionInfo[];
    addCommandAvailabilityListener(listener: ICommandAvailabilityListener): void;
    removeCommandAvailabilityListener(listener: ICommandAvailabilityListener): void;
    addCommandStateChangedListener(listener: ICommandStateChangedListener): void;
    removeCommandStateChangedListener(listener: ICommandStateChangedListener): void;
    private _changingContent;
    get changingContent(): EventEmitter<{
        sender: any;
        args: IgxDashboardTileChangingContentEventArgs;
    }>;
    private _filterStringErrorsParsing;
    get filterStringErrorsParsing(): EventEmitter<{
        sender: any;
        args: IgxDashboardTileFilterStringErrorsParsingEventArgs;
    }>;
    protected _zoneRunner: (act: () => void) => void;
    protected _runInZone(act: () => void): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<IgxDashboardTileComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<IgxDashboardTileComponent, "igx-dashboard-tile", never, { "height": "height"; "width": "width"; "tileTitle": "tileTitle"; "initialSorts": "initialSorts"; "groupSorts": "groupSorts"; "initialGroups": "initialGroups"; "initialFilter": "initialFilter"; "initialHighlightFilter": "initialHighlightFilter"; "initialSummaries": "initialSummaries"; "dataSource": "dataSource"; "highlightedDataSource": "highlightedDataSource"; "shouldDisplayMockData": "shouldDisplayMockData"; "shouldAvoidAxisAnnotationCollisions": "shouldAvoidAxisAnnotationCollisions"; "trendLineType": "trendLineType"; "shouldUseSkeletonStyleForMockData": "shouldUseSkeletonStyleForMockData"; "highlightedValuesDisplayMode": "highlightedValuesDisplayMode"; "includedProperties": "includedProperties"; "validVisualizationTypes": "validVisualizationTypes"; "excludedProperties": "excludedProperties"; "brushes": "brushes"; "outlines": "outlines"; "selectedSeriesItems": "selectedSeriesItems"; "actualBrushes": "actualBrushes"; "actualOutlines": "actualOutlines"; "categoryAxisMajorStroke": "categoryAxisMajorStroke"; "valueLines": "valueLines"; "valueLinesBrushes": "valueLinesBrushes"; "autoCalloutsVisible": "autoCalloutsVisible"; "crosshairsAnnotationEnabled": "crosshairsAnnotationEnabled"; "finalValueAnnotationsVisible": "finalValueAnnotationsVisible"; "crosshairsDisplayMode": "crosshairsDisplayMode"; "visualizationType": "visualizationType"; "validVisualizationTypePriorityThreshold": "validVisualizationTypePriorityThreshold"; "baseTheme": "baseTheme"; "density": "density"; "backgroundColor": "backgroundColor"; }, { "changingContent": "changingContent"; "filterStringErrorsParsing": "filterStringErrorsParsing"; }, ["contentCustomizations"], ["*"]>;
}
